;trol
;NOTICE: Compile this as a .gg as it is designed to run in GG Mode!!!
;==============================================================
; WLA-DX banking setup
;==============================================================
.memorymap
defaultslot 0
slotsize $8000
slot 0 $0000
.endme
.rombankmap
bankstotal 1
banksize $8000
banks 1
.endro
;==============================================================
;GG Defines
;==============================================================
.include "Useful functions.asm"
.define GGOne $00 ;start and national
.define GGTwo $01
.define GGThree $02
.define GGFour $03
.define GGFive $04
.define GGSix $05
.define GGStereo $06
.define MemCtrl $07
.define IOCtrl $08
.define VCnt $7e
.define HCnt $7f
;.define VDPCtrl $bf    ;$BE = Data port (r/w)
;.define VDPData $be    ;$BF = Control port (r/w)
.define IOAB $c0
.define IOBMisc $c1
.define Joypad $dc
.define VRAMWrite $4000
.define CRAMWrite $c000
;.define
;Controller bits
/*.define PU %00000001
.define PD %00000010
.define PL %00000100
.define PR %00001000
.define P1 %00010000
.define P2 %00100000*/
;.define ram $c000
;.STRUCT cc
.enum $c000
    Deaths        dw            ;Death count
    Level         db            ;Current level
    CurrentPlayer db            ;
    Timer         dw
    CameraX       db
    CameraY       db
    Pause         db
    debug         db            ;Debug mode flag
    VBlankFlag    db   		;VBlank flag
    MaxVCount     db
    jugthings     db            ;Default value is 2 (Michael Rosen approves)
    Control       db
    Screen        db
.ende;st
;==============================================================
; SDSC tag and Rom header
;==============================================================
.sdsctag 1.10,"Game GG","crud","RJ Games"
;.include "Useful functions.inc"
.bank 0 slot 0
.org $0000
;==============================================================
; Boot section
;==============================================================
    di              ; disable interrupts
    im 1            ; Interrupt mode 1
    jp Main         ; jump to main program
.org $0018 ; rst $18 = error
.section "$18 error stuff" force
  jr ErrorHandler
.ends
.org $0038
  push af
    in a,(VDPData)        ; read port to satisfy interrupt (VDPCtrl)
    ld a,1                ; the only interrupt enabled is VBlank so...
    ld (VBlankFlag),a     ; ... write down that it actually happened
  pop af
  ei                            ; enable interrupt (that were disabled by the IRQ call)
  reti                          ; return from interrupt
.org $0066
;==============================================================
;NMI handler
;==============================================================
    ;Do nothing
    retn
.macro SCROLL ;X, Y
       ld a, (\1)
       out (VDPAddress), a        ; Send data (note: the data is send FIRST)
       ld a, VDPRegHScroll             ; Get the VDP register in [a]
       out (VDPAddress), a        ; Select register
       ld a, (\2)
       out (VDPAddress), a        ; Send data (note: the data is send FIRST)
       ld a, VDPRegVScroll             ; Get the VDP register in [a]
       out (VDPAddress), a        ; Select register
.endm
.macro LOADTILES
;LOADTILES starttile, tile data, tilestoload, bpp
;hl, ix, bc, d
       ld hl, \1
       ld ix, \2
       ld bc, \3
       ld d, \4
       call LoadTiles
.endm
.macro LOADPAL
;LOADPAL location, valueswrite, palleteindex,
;hl, b, c
       ld hl, \1
       ld b, \2
       ld c, \3
       call LoadPalette
.endm
.macro TEXT
.asc \1
.db $FF
.endm
.macro PRINT
       ld iy, (\1 + \2 * 32) * 2 | TileMapAddress
       ld hl, \3
       call WriteASCII
.endm
.macro NUMBER
       ld hl, (\1 + \2 * 32) * 2 | TileMapAddress
       call VRAMToHL
       ld a, (\3)
       call WriteNumber
.endm
.macro WRITETILES
       ld iy, (\1 + \2 * 32) * 2 | TileMapAddress
       ld hl, \3
       call WriteTiles
.endm
ErrorHandler:
   call ClearVRAM
   call DefaultInitialiseVDP
   LOADTILES $0000, FontData, 95, 1;4
   PRINT 6, 3, Text ;ErrorMessage
   -:call ReadStart
     and PS
     jp nz, $0000
     jr -

;**Main code
Main:
    ld sp, $dff0
    call ClearVRAM
    call DefaultInitialiseVDP
    call ScreenOff

    LOADTILES $0000, FontData, 95, 1;4
    LOADPAL PaletteData, 32, 0
    LOADPAL PaletteData, 32, 32

    LOADTILES $0060, SegaRJgfx, 86, 4

    xor a
    ld (Screen), a

--: ;call ScreenOff
    ;call ClearScreen

-:  call ReadStart
    and PS
    jp nz, -
    ;jr -
    call ScreenOff
    call ClearScreen

    ld a, (Screen)
    inc a
    ld (Screen), a

    cp $01
    jp z, +

    cp $02
    jp z, ++

    cp $03
    jp z, +++

    cp $04
    jp z, Title

+:
    WRITETILES 12, 10, SEGASplash
    jr ++++
++:
    ;WRITETILES 12, 10, RJSplash
    WRITETILES 9, 10, RJSplash
    jr ++++
+++:
    ;WRITETILES 12, 10, C16Splash
    WRITETILES 9, 10, C16Splash
    jr ++++
++++:
    call ScreenOn
    ;ld a, (Screen)
    ;inc a
    ;ld (Screen), a

-:  call ReadStart
    and PS
    jp nz, --
    jr -

Title:
    call ScreenOff
    call ClearScreen
    LOADTILES $0060, IntroLogo, 110, 4
    WRITETILES 8, 8, TitleSplash
    call ScreenOn

-:  call ReadStart
    and PS
    jp nz, -

-:
    jr -;Title


;WriteTextWithLocation
;==============================================================
;Data / misc
;==============================================================
;.bank 1 slot 0
;Message:
;     TEXT "@2015 RJ Games"
SEGASplash:
     .dw $0060, $0061, $0062, $0063, $0064, $0065, $0066, $0067, $0068 ;68
     .db 1
     .dw $0070, $0071, $0072, $0073, $0074, $0075, $0076, $0077, $0000
     .db 1
     .dw $0080, $0081, $0082, $0083, $0084, $0085, $0086, $0087
     .db $ff
RJSplash:
     ;   R      E      T      R      O             J      O      U      R      N      E      Y      TM
     .dw $0090, $0091, $0092, $0090, $0093, $00a8, $0094, $0093, $0095, $0090, $0096, $0091, $0097, $0098
     .db 1
     .dw $00a0, $00a1, $00a2, $00a0, $00a3, $00a8, $00a4, $00a3, $00a5, $00a0, $00a6, $00a1, $00a7
     .db $FF
C16Splash:
     .dw $0030, $0032, $002f, $0027, $0032, $0021, $002d, $002d, $0025, $0024, $00a8, $0022, $0039
     .db 1
     .dw $006a, $006b, $0000, $0099, $009a, $009b, $0092, $0090, $0093, $0096, $009c, $0099, $00a8, $00a8
     .db 1
     .dw $007a, $007b, $0000, $00a9, $00aa, $00ab, $00a2, $00a0, $00a3, $00a6, $00ac, $00a9, $0011, $0016
     .db $ff
TitleSplash:
     .dw $0060, $0060, $0060, $0061, $0062, $0063, $0064, $0065, $0066, $0067, $0068, $0069, $006A
     .db 1
     .dw $0060, $0060, $0060, $0071, $0072, $0073, $0074, $0075, $0076, $0077, $0078, $0079, $007A
     .db 1
     .dw $0060, $0060, $0060, $0081, $0082, $0083, $0084, $0085, $0086, $0087, $0088, $0089, $008A
     .db 1
     .dw $0060, $0060, $0090, $0091, $0092, $0093, $0094, $0095, $0096, $0097, $0098, $0099, $009A, $009B
     .db 1
     .dw $0060, $0060, $00A0, $00A1, $00A2, $00A3, $00A4, $00A5, $00A6, $00A7, $00A8, $00A9, $00AA, $00AB
     .db 1
     .dw $0060, $0060, $00B0, $00B1, $00B2, $00B3, $00B4, $00B5, $00B6, $00B7, $00B8, $00B9, $00BA, $00BB
     .db 1
     .dw $0020, $0012, $0010, $0011, $0015, $0060, $0032, $002A, $0060, $0027, $0021, $002D, $0025, $0033
     .db 1
     .dw $0020, $0012, $0010, $0011, $0013, $0060, $0022, $0035, $0029, $002C, $0024, $0025, $0032, $0022, $002F, $0039
     .db 1
     .dw $0060, $0060, $0030, $0052, $0045, $0053, $0053, $0060, $0033, $0054, $0041, $0052, $0054
     .db $ff

PaletteData:
;Byte:	1             0
;Bit:	7 6 5 4	3 2 1 0 7 6 5 4 3 2 1 0
;%	      U	      B       G       R
.dw $0000              ;16
.dw $0fff
.dw $0aaf
.dw $0bee  ;Beef, dad.
.dw $0fda  ;
.dw $000d  ;
.dw $03de
.dw $06bb
.dw $0367
.dw $0145
.dw $0ddd
.dw $0aaa
.dw $02ad
.dw $02e8
.dw $01d7
.dw $00c6
;.dw $0bgr

FontData:
.incbin "OrigGFX\Text.GG" read 95*8*1;4 ;tilecount*8*BPP
SegaRJgfx:
.incbin "OrigGFX\SegaRJ.GG" read 86*8*4
IntroLogo:
.incbin "OrigGFX\Text.GG" read 110*8*4
LevelGfx:
.incbin "OrigGFX\Level.GG" read 13*8*4
PlayerGfx:
.incbin "OrigGFX\Player.GG" read 12*8*4
Text:
.incbin "messige.txt"
.db $ff
